mode(-1);
x_message([..
    "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",..
    "@                                                        @",..
    "@                    MinMax[[g,d]]                       @",..
    "@                     Version 0.1                        @",..
    "@      L.Hardouin, B.Gruet, B.Cottenceau & M.Lhommeau    @",..
    "@                                                        @",..
    "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",..
    "                                                          ",..
    "                      OUTLINE:                            ",..
    "                                                          ",..
    " 1) MinMax[[gamma,delta]]  Series and Matrices            ",..
    " 2) Various calculations                                  ",.. 
    " 3) Application to Production Systems                     "]);

x_message(["",..
"======================================================",..
"= 1) MinMax[[gamma,delta]] TYPE, SERIES AND MATRICES =",..
"======================================================",""]);
mode(7)
//monome constants
// epsilon
eps
//Top
top
//e
e
//series constants
// series epsilon
s_eps
// series Top
s_top
// series e
s_e
//series Initialization s1 = p +qr^*
p = [1 2; 2 4 ; 5 6]
q = [8 8 ; 9 9]
r = [5 5]

s1 = series(p,q,r)
//another way to Initialize series
s2 = series([1 2;2 4; 5 6],[8 8 ; 9 9],[5 5])
//Typeof s2 = mmgd
typeof(s2)
//Type s2 = 258
type(s2)
//vector of series initialization
a = [s1 ; s2 ; series([1 1 ; 2 3 ; 4 5],[8 9 ; 10 15],[7 3])]
//typeof(a) = mmgd
typeof(a)
//transpose vector initialization
a = [s1 series([2 2],[4 5],[2 2])]
//typeof a = mmgd
typeof(a)
//MinMax[[gamma,delta]] matrix creation
a = [series([1 1 ; 5 5],[7 8 ; 10 11],[6 7]) s1 s2 ; s2 series([5 7],[9 10],[11 12]) s1]
//typeof a = mmgd
typeof(a)
mode(-1);
x_message([..
    "==========================================================",..
    "=         2)VARIOUS CALCULATIONS                         =",..
    "=========================================================="]);
mode(7);
// sum of 2 series
s1+s2
// product of 2 series
s1 * s2
// initialization matrix of series 
b= [s1 s2 ; s1 s1 ; s1 series([1 1 ; 2 2],[8 8 ; 10 15],[7 5])]
// matrix transposition
b'
// matrix product
a * b
// Kleene star of matrix 
a = smatrix(2,2);
a(1,1) = series([1 2 ; 2 2],[4 5],[3 2]);
a(2,2) = series([5 5],[6 7 ; 8 10],[2 4])

stargd(a)

b = [s1 s1 ; s1 s1];

// matrix residuation or series residuation
a \ b
a / b
s2\ s1
// inf of matrix
a ^ b
//inf of series
s1 ^ s2
mode(-1);
x_message([..
    "===========================================================",..
    "=         3)Application to Production Systems             =",..
    "= exec examples/automatica_2001.sce                       =",..
    "= exec examples/ifac2001.sce                              =",..
    "= exec examples/olsder_subiono_Mcgettrick.sce             =",..
    "=========================================================="]);
x_message([..
" =============",..
" =           =",..
" =  END      =",..
" =           =",..
" ============="]);





