/////////////////////////////////////////////////////////////////////
// Example : IFAC 2001 Prague
//           "On timed event graph stabilization by output 
//				feedback in dioid"
         
//		   WORKSHOP ON MAX-PLUS ALGEBRAS

//         to be held in Praha, 27-29 August, 2001,
//                as a Satellite Event of the
//    1rst IFAC Symposium on System Structure and Control.


	
/////////////////////////////////////////////////////////////////////
		
//  system parameters

//		n1,t1 : n1/t1 production rate of machine M1
//		n2,t2 : n2/t2 production rate of machine M2
//		n3,t3 : n3/t3 production rate of machine M3
//		n4,t4 : n4/t4 production rate of machine M4
	
//		t5,t6,t7 : delays M1->M3 M2->M3 M2->M4*/

mode(7);
	    n1=2 ,t1=2 ,n2=3 ,t2=3 ,n3=1 ,t3=1 ,n4=1 ,t4=15 ,t5=3 ,t6=3 ,t7=2;
//*****************************************************/
// state representation : X = AX + BU and Y = CX */

	// state matrix
	A = smatrix(12,12);
	
	A(2,1)=s_e;
	A(2,3)=series(eps,[n1 0],e);
	A(3,2)=series(eps,[0 t1],e);
	A(4,3)=series(eps,[0 t5],e);
	A(4,5)=series(eps,[n3 0],e);
	A(5,4)=series(eps,[0 t3],e);
	A(6,5)=s_e;
	A(4,9)=series(eps,[0 t6],e);
	A(8,7)=s_e;
	A(9,8)=series(eps,[0 t2],e);
	A(8,9)=series(eps,[n2,0],e);
	A(10,9)=series(eps,[0 t7],e);
	A(10,11)=series(eps,[n4 0],e);
	A(11,10)=series(eps,[0 t4],e);
	A(12,11)=s_e;
	
	
	// input and output matrices	
    B = smatrix(12,2);
    C = smatrix(2,12);
    
	C(1,6)=s_e;	
	C(2,12)=s_e;	

	B(1,1)=s_e;	
	B(7,2)=s_e;

///*****************************************************
// transfer matrix computation  H = CA*B

	H= C*stargd(A)*B

	
//******************************************************/
// the production rate is that of the bottleneck machine
// open-loop production rate = 

    tauxDeProduction = min(min(n1/t1,n2/t2),min(n3/t3,n4/t4))
    
    
    
//******************************************************/
// the output feedback is such that the whole system has the production 
// rate of the bottle neck machine

    k1=ceil(tauxDeProduction*(t1+t3+t5))
	k2=ceil(tauxDeProduction*(t2+t3+t6))
	k3=ceil(tauxDeProduction*(t2+t4+t7))
	
//******************************************************/
// the feedback which minimizes the number of tokens is denoted by Fro
	
	Fro = smatrix(2,2);
	
	Fro(1,1)=series(eps,[k1 0],e);
	Fro(1,2)=series(eps,eps,e);
	Fro(2,1)=series(eps,[k2 0],e);
	Fro(2,2)=series(eps,[k3 0],e)
		
//******************************************************/
// the closed loop transfer with the feedback Fro is given by Gbf=H(Fro H)*


	Gbf= H*stargd(Fro*H)
	
//******************************************************/
// the feedback Fopt is given by Fopt=prcaus(H\Gbf/H)
	
	Fopt=prcaus(H\Gbf/H)


